//! Parse args
use super::*;

pub fn usage() -> !
{
    println!(r#"Usage: {program} <files...>

VersIoning DELeter v{version}, by {authours} with <3
  (Licensed GPL 3.0 or later)"#,
	     program = program_name(),
	     version = env!("CARGO_PKG_VERSION"),
	     authours = env!("CARGO_PKG_AUTHORS"));
    std::process::exit(1)
}

pub fn program_name() -> &'static str
{
    lazy_static! {
	static ref PROGRAM: String = std::env::args().next().unwrap();
    }
    &PROGRAM[..]
}

pub fn process<F, T>(mut callback: F) -> impl Future<Output= eyre::Result<usize>>
where F: FnMut(String) -> T,
      T: Future + Send + 'static,
      T::Output: Send
{
    let args = std::env::args();
    let output: Vec<_> = args.skip(1).map(|arg| tokio::spawn(callback(arg))).collect();
    async move {
	let mut j=0;
	for (i, x) in (0..).zip(futures::future::join_all(output).await) {
	    x
		.wrap_err(eyre!("Child panic or cancel"))
		.with_note(|| format!("Child {}", i).header("While processing"))?;
	    j+=1;
	}
	Ok(j)
    }
}
